/* Postgres Julian Day function 
   -----------------------------
   written by Dirk Jagdmann <doj@cubic.org>

   this algorithm is ripped from perl Time-modules package written by
   David Muir Sharnoff <muir@idiom.com>
*/

#include <postgres.h>
#include <fmgr.h>

#ifdef V70x
int4 int_to_julian_date(int4 y, int4 m, int4 d)
{
#endif

#ifdef V71x
PG_FUNCTION_INFO_V1(int_to_julian_date);

Datum
int_to_julian_date(PG_FUNCTION_ARGS)
{
  const int32 y=PG_GETARG_INT32(0);
  const int32 m=PG_GETARG_INT32(1);
  const int32 d=PG_GETARG_INT32(2);
#endif

  const int mm=(14-m)/12;

  const int r=d - 32075
    + 1461 * ( y + 4800 - mm ) / 4
    + 367 * ( m - 2 +  mm * 12 ) / 12
    - 3 * ( ( y + 4900 - mm ) / 100 ) / 4;

#ifdef V70x
  return r;
#endif

#ifdef V71x 
  PG_RETURN_INT32(r);
#endif

}
